/***************************************************************************
 *   Copyright (C) 2008 by S. MANKOWSKI / G. DE BURE skrooge@miraks.com    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>  *
 ***************************************************************************/
/** @file
 * This file is a test script.
 *
 * @author Stephane MANKOWSKI / Guillaume DE BURE
 */
#include "skgtestmacro.h"
#include "skgimportexportmanager.h"
#include "skgbankincludes.h"

/**
 * The main function of the unit test
 * @param argc the number of arguments
 * @param argv the list of arguments
 */
int main(int argc, char** argv)
{
        Q_UNUSED(argc);
        Q_UNUSED(argv);

        //Init test
        SKGINITTEST(true);

        QDate now=QDate::currentDate();

        {
                //Test import SKGImportExportManager::CSV skrooge
                SKGDocumentBank document1;
                SKGTESTERROR("document1.initialize()", document1.initialize(), true);

                SKGError err;
                {
                        //Scrope of the transaction
                        SKGBEGINTRANSACTION(document1, "IMPORT", err);
                        {
                                SKGImportExportManager imp1(&document1, SKGImportExportManager::CSVUNIT, getTestPath("IN")+"/skgtestimportcsvunit/notfound.csv");
                                SKGTESTERROR("imp1.importFile", imp1.importFile(), false); //FILE NOT FOUND
                        }
                        {
                                SKGImportExportManager imp1(&document1, SKGImportExportManager::CSVUNIT, getTestPath("IN")+"/skgtestimportcsvunit/test.csv");
                                SKGTESTERROR("imp1.importFile", imp1.importFile(), true);
                        }
                        {
                                SKGImportExportManager imp1(&document1, SKGImportExportManager::CSVUNIT, getTestPath("IN")+"/skgtestimportcsvunit/test2.csv");
                                SKGTESTERROR("imp1.importFile", imp1.importFile(), true);
                        }
                }
                document1.dump(DUMPUNIT);
                {
                        SKGUnitObject unit(&document1);
                        SKGTESTERROR("UNIT.setName", unit.setName("test"), true);
                        SKGTESTERROR("UNIT.load", unit.load(), true);
                        SKGUnitValueObject UnitValue;
                        SKGTESTERROR("UNIT.getLastUnitValue", unit.getLastUnitValue(UnitValue), true);
                        SKGTEST("UNIT:getQuantity", SKGServices::doubleToString(UnitValue.getQuantity()), "50");
                }
                {
                        SKGUnitObject unit(&document1);
                        SKGTESTERROR("UNIT.setName", unit.setName("test2"), true);
                        SKGTESTERROR("UNIT.load", unit.load(), true);
                        SKGUnitValueObject UnitValue;
                        SKGTESTERROR("UNIT.getLastUnitValue", unit.getLastUnitValue(UnitValue), true);
                        SKGTEST("UNIT:getQuantity", SKGServices::doubleToString(UnitValue.getQuantity()), "25.16");
                }
        }

        //End test
        SKGENDTEST();
}
